=== contrib/cgreen-mocker/requirements.txt ===
pycparser
packaging
