=== debian/changelog ===
cgreen (1.6.4-3) unstable; urgency=medium

  * d/control: replace asciidoctor-pdf with asciidoctor.
  * d/doc: install the locally generated HTML guide.
  * d/doc-base: reference the HTML guide.
  * d/rules: disable PDF docs and strip remote assets from HTML build.

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Sat, 01 Nov 2025 09:51:44 +0800

cgreen (1.6.4-2) unstable; urgency=medium

  * d/control:
    - Change Build-Depends from ruby-asciidoctor-pdf to asciidoctor-pdf
      (Closes: #1114079, #1112773)
    - Bump Standards-Version to 4.7.2
  * d/watch: Upgrade to version 5 format.
  * Add patch to fix uninitialized value in make_cgreen_integer_value

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Fri, 05 Sep 2025 13:56:19 +0800

cgreen (1.6.4-1) unstable; urgency=medium

  * Upload to unstable

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Sun, 16 Feb 2025 22:57:46 +0800

cgreen (1.6.4-1~exp1) experimental; urgency=medium

  * Import new upstream release
  * d/control: Bump Standards-Version to 4.7.0

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Fri, 31 Jan 2025 00:26:35 +0800
