=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
# Disable fixfilepath as it triggers build failures.
export DEB_BUILD_MAINT_OPTIONS := hardening=+all reproducible=-fixfilepath
export DEB_CFLAGS_MAINT_APPEND := -Wall -D_FORTIFY_SOURCE=2 -O1
SRC	:= $(CURDIR)
BUILD	:= $(SRC)/build
TARGET	:= $(SRC)/debian/tmp

%:
	dh $@

override_dh_auto_test:
	if ! LD_LIBRARY_PATH="$(BUILD)/src/" dh_auto_test; then \
		cat $(BUILD)/Testing/Temporary/LastTest.log; \
		exit 1; \
	fi

override_dh_auto_configure:
	[ -d $(BUILD) ] || mkdir $(BUILD)
	cd $(BUILD) && cmake $(CURDIR) -DCMAKE_INSTALL_PREFIX="/usr" \
		-DCMAKE_C_FLAGS="${CFLAGS} $(DEB_CFLAGS_MAINT_APPEND) -fzero-init-padding-bits=unions" \
		-DCMAKE_SKIP_RPATH=ON \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DLIB_INSTALL_DIR=/usr/lib \
		-DCGREEN_WITH_PDF_DOCS:bool=FALSE
	touch configure-stamp

override_dh_auto_build:
	dh_auto_build
	mkdir -p $(BUILD)/doc
	asciidoctor -a docinfo -a linkcss! -a icons! -a source-highlighter! -a webfonts! \
		-o $(BUILD)/doc/cgreen-guide-en.html doc/cgreen-guide-en.asciidoc

override_dh_clean:
	rm -f configure-stamp build-stamp gitrevision.h
	rm -rf $(BUILD)
	dh_clean
