=== debian/tests/control ===
Tests: testsuite
Restrictions: allow-stderr, superficial
Depends: @

Tests: run-cgreen-test
Restrictions: allow-stderr
Depends: @, build-essential
