=== debian/watch ===
Version: 5

Source: https://github.com/cgreen-devs/cgreen/tags
Matching-Pattern: .*/v?(\d\S*)\.tar\.gz
Filenamemangle: s/.+\/v?(\d\S*)\.tar\.gz/cgreen-$1\.tar\.gz/
